Subject: Re: Git log bug

From: Junio C Hamano <[email-masked]>
Date: Fri, 29 Sep 2023 08:12:44 -0700

liangxiong zhu <[email-masked]> writes:

> git clone $repo_url $repo_name
> cd $repo_name
> mkdir dir01
> mkdir dir02
> touch dir01/file01.txt
> git add .
> git commit -m 'Add file01.txt'
> git push
>
> touch dir02/file02.txt
> git add .
> git commit -m 'Add file02.txt'
> git push
>
> git log -1 -- dir01
>
> What did you expect to happen? (Expected behavior)
> print out commit with message 'Add file01.txt'
>
> What happened instead? (Actual behavior)
> print out commit with message 'Add file02.txt'

Thanks, but it does not reproduce with the above procedure.
Following the above (with $repo_name set to "trash" that is not a
name of any existing directory in the current directory, and
$repo_url set to a local repository that exists but without any
history), I got the "Add file01.txt" from the last step.

I got

    No refs in common and none specified; doing nothing.
    Perhaps you should specify a branch.
    fatal: the remote end hung up unexpectedly
    error: failed to push some refs to '/var/tmp/x/./empty.git'

after both of "git push", but becuase "git log" that does not say
where to start cares only about HEAD, in the above reproduction
precipe "git push" should be irrelevant (i.e., if your copy of Git
is broken to exhibit the above reported bug, it should show the same
symptom without these steps to run "git push").

If there are some hooks that modifies the history after your "git
push", it would be a different story, but otherwise I am not sure
how any version of Git would exhibit such a symptom.

Puzzled.